package com.blogspot.lucbors.actrk.view.beans;

import com.blogspot.lucbors.actrk.view.util.ADFUtils;

import com.blogspot.lucbors.actrk.view.util.JSFUtils;

import java.util.ArrayList;

import javax.el.ELContext;
import javax.el.ExpressionFactory;
import javax.el.MethodExpression;

import javax.faces.application.Application;
import javax.faces.context.FacesContext;
import javax.faces.event.ActionEvent;

import oracle.adf.model.BindingContainer;
import oracle.adf.model.binding.DCBindingContainer;
import oracle.adf.model.binding.DCIteratorBinding;
import oracle.adf.share.ADFContext;

import oracle.adf.view.rich.component.rich.data.RichTable;

import oracle.adf.view.rich.component.rich.data.RichTree;

import oracle.adf.view.rich.context.AdfFacesContext;

import oracle.jbo.Key;
import oracle.jbo.Row;
import oracle.jbo.RowSetIterator;

import org.apache.myfaces.trinidad.event.SelectionEvent;
import org.apache.myfaces.trinidad.model.RowKeySet;
import org.apache.myfaces.trinidad.model.RowKeySetImpl;

public class EmpsBean {

  private String searchValue;
  private Key key;
  private RichTable empTable;

  public EmpsBean() {
  }

  public void gotoPressed(ActionEvent actionEvent) {
    // Add event code here...

    DCIteratorBinding it = ADFUtils.findIterator("Employees1Iterator");
    RowSetIterator rsi = it.getRowSetIterator();
    RowKeySet oldSelection = empTable.getSelectedRowKeys();

    if (rsi.first() != null) {
      Row r = rsi.first();
           while (rsi.hasNext() && getKey() == null && (!matchFound(r,oldSelection))) {
                   r = rsi.next();
      }
    }


  }

  private boolean matchFound (Row r,RowKeySet oldSelection){
    setKey(null);
    ArrayList lst = new ArrayList(1);
    RowKeySetImpl newSelection = new RowKeySetImpl();
    Key key = null;
    String rowValue = (String)r.getAttribute("LastName");
    if (rowValue.toString().contains(searchValue)) {
      System.out.println("now setting key to " + key);
      key = r.getKey();
      lst.add(key);
      empTable.setActiveRowKey(lst);
      newSelection.add(lst);
      makeCurrent(empTable, newSelection, oldSelection);  
      return true;
    }
    return false;
    
  }

  private void makeCurrent(RichTable empTable, RowKeySet newCurrentRow, RowKeySet oldCurrentRow) {
    //To make a row current, we need to create a SelectionEvent which
    //expects the following arguments: component, unselected_keys,
    //selected_keys. In our example, we don't have unselected keys and
    //therefore create an empty RowSet for this
    SelectionEvent selectionEvent =
      new SelectionEvent(oldCurrentRow, newCurrentRow, empTable);
      selectionEvent.queue();
      AdfFacesContext.getCurrentInstance().addPartialTarget(empTable);
  }

  
  public void setSearchValue(String searchValue) {
    this.searchValue = searchValue;
  }

  public String getSearchValue() {
    return searchValue;
  }

  public void setKey(Key key) {
    this.key = key;
  }

  public Key getKey() {
    return key;
  }


  public void setEmpTable(RichTable empTable) {
    this.empTable = empTable;
  }

  public RichTable getEmpTable() {
    return empTable;
  }
}
